require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.
#
# Also compared to earlier versions of this generator, there are no longer any
# expectations of assigns and templates rendered. These features have been
# removed from Rails core in Rails 5, but can be added back in via the
# `rails-controller-testing` gem.

RSpec.describe IgemUsersController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # IgemUser. As you add validations to IgemUser, be sure to
  # adjust the attributes here as well.
  before :all do
    @user = FactoryBot.create(:user)
    @user.add_role :admin
    @team = FactoryBot.create(:team)
  end

  let(:auth_headers) do
    headers = { 'Accept' => 'application/json', 'Content-Type' => 'application/json' }
    Devise::JWT::TestHelpers.auth_headers(headers, @user)
  end

  let(:valid_attributes) {
    {
      igem_user: {
        username: "Johny",
        igem_team_id: @team.igem_team_id
      }
    }
  }

  let(:invalid_attributes) {
    {
      igem_user: {
        igem_team_id: @team.igem_team_id
      }
    }
  }

  before :each do
    request.headers.merge! auth_headers
  end


  describe "GET #index" do
    it "returns a success response" do
      igem_user = IgemUser.create! valid_attributes
      get :index, params: {}
      expect(response).to be_successful
    end
  end

  describe "GET #show" do
    it "returns a success response" do
      igem_user = IgemUser.create! valid_attributes
      get :show, params: {id: igem_user.to_param}
      expect(response).to be_successful
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new IgemUser" do
        expect {
          post :create, params: {igem_user: valid_attributes}
        }.to change(IgemUser, :count).by(1)
      end

      it "renders a JSON response with the new igem_user" do

        post :create, params: {igem_user: valid_attributes}
        expect(response).to have_http_status(:created)
        expect(response.content_type).to eq('application/json')
        expect(response.location).to eq(igem_user_url(IgemUser.last))
      end
    end

    context "with invalid params" do
      it "renders a JSON response with errors for the new igem_user" do

        post :create, params: {igem_user: invalid_attributes}
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to eq('application/json')
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it "updates the requested igem_user" do
        igem_user = IgemUser.create! valid_attributes
        put :update, params: {id: igem_user.to_param, igem_user: new_attributes}
        igem_user.reload
        skip("Add assertions for updated state")
      end

      it "renders a JSON response with the igem_user" do
        igem_user = IgemUser.create! valid_attributes

        put :update, params: {id: igem_user.to_param, igem_user: valid_attributes}
        expect(response).to have_http_status(:ok)
        expect(response.content_type).to eq('application/json')
      end
    end

    context "with invalid params" do
      it "renders a JSON response with errors for the igem_user" do
        igem_user = IgemUser.create! valid_attributes

        put :update, params: {id: igem_user.to_param, igem_user: invalid_attributes}
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to eq('application/json')
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested igem_user" do
      igem_user = IgemUser.create! valid_attributes
      expect {
        delete :destroy, params: {id: igem_user.to_param}
      }.to change(IgemUser, :count).by(-1)
    end
  end

end
